package com.b510.hbase.util.dao;

import java.util.List;

import org.apache.hadoop.hbase.client.HTableInterface;


/**
 * @author Hongten
 * @created 7 Nov 2018
 */
public interface HbaseDao {

	// initial table
	public HTableInterface getHTableFromPool(String tableName);

	// check if the table is exist
	public boolean isHTableExist(String tableName);

	// create table
	public void createHTable(String tableName, String[] columnFamilys);

	// insert new row
	public void addRow(String tableName, String rowKey, String columnFamily, String column, String value);

	// get row by row key
	public void getRow(String tableName, String rowKey);

	public void getAllRows(String tableName);

	// get rows by giving range
	public void getRowsByRange(String tableName, String startRowKey, String endRowKey);

	//delete row
	public void delRow(String tableName, String rowKey);
	
	//delete rows by row keys
	public void delRowsByRowKeys(String tableName, List<String> rowKeys);

	// auto flush data when close
	public void closeAutoFlush(HTableInterface table);

	// close table
	public void closeTable(HTableInterface table);

	// close pool connection
	public void closePoolConnection();

	// delete table
	public void deleteHTable(String tableName);
}
